unit USB_Array;
//----------------------------------------------------------------------
// USB Arrays Example By S R Woodall. May 2009
// Note 1: you will need the Pro Edition to translate database related code.
// Note 2: If Flowcode USB Slave service_macro used set to char,string.
//----------------------------------------------------------------------
interface
uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, menus, extctrls, buttons, clipbrd, MMSystem;
Type
   TForm1Cls = class(TForm)
    Byte0: TEdit;
    Nos1: TEdit;    Nos2: TEdit;    Nos3: TEdit;
    Nos4: TEdit;    Nos5: TEdit;    Nos6: TEdit;
    Str: TEdit;                 Text1: TMemo;
    btnOpen: TButton;           btnGetCount: TButton;       btnClose: TButton;
    Trans_Byte: TButton;        Trans_Int: TButton;         Trans_Str: TButton;
    Rec_Byte: TButton;          Rec_Int: TButton;           Rec_Str: TButton;
    Label1: TLabel;             Label2: TLabel;
    Label3: TLabel;             Label4: TLabel;
    Label5: TLabel;             Label6: TLabel;
    Label7: TLabel;             Label8: TLabel;

    procedure btnGetCount_Click(Sender: TObject );
    procedure btnOpen_Click(Sender: TObject );
    procedure Trans_ByteClick(Sender: TObject);
    procedure Trans_IntClick(Sender: TObject);
    procedure Rec_ByteClick(Sender: TObject);
    procedure Rec_IntClick(Sender: TObject);
    procedure btnClose_Click(Sender: TObject );
    procedure Form_Unload(Sender: TObject; var Action: TCloseAction);
    procedure TransCommon;
    procedure Trans_StrClick(Sender: TObject);
    procedure Rec_StrClick(Sender: TObject);
    private TranType: Byte;
    public
end;

type ArByte = array [0..31] of byte;
     ArChar = array [0..17] of char;
     PDWORD = ^DWord; //This is the conversion from VB !

var sID: ArChar = 'vid_12bf&pid_f030';
    LastDO1: byte;

var
   Form1Cls : TForm1Cls;
   function ECIO_GetDLLVersion(): longint; stdcall; external 'ECIO_api.dll';
   function ECIO_Open(index: longint; pVID_PID: ArChar): longint;
                      stdcall; external 'ECIO_api.dll';
   function ECIO_Close(): longint; stdcall; external 'ECIO_api.dll';
   function ECIO_Transmit(pDataOut: ArByte;
                          dwLenOut: longint;
                          pActualLenOut: PDWORD;
                          pDataIn: ArByte;
                          dwExpectedLenIn: longint;
                          pActualLenIn: PDWORD;
                          dwTimeout: longint): longint;
                          stdcall; external 'ECIO_api.dll';
   function ECIO_GetDeviceCount(pVID_PID: ArChar): longint;
                                stdcall; external 'ECIO_api.dll';

   Const CR = Chr(13)+Chr(10);

implementation
{$R *.dfm}

procedure TForm1Cls.btnGetCount_Click(Sender: TObject);
var lCnt : longint;
begin
   lCnt := ECIO_GetDeviceCount(sID);
   Text1.text := Text1.text+'Count = '+IntToStr(lCnt)+CR;
end;

procedure TForm1Cls.btnOpen_Click(Sender: TObject);
var lRetVal : longint;
begin
   lRetVal := ECIO_Open(0, sID);
   Text1.text := Text1.text+'Open = '+IntToStr(lRetVal)+CR;
end;

procedure TForm1Cls.Trans_ByteClick(Sender: TObject);
begin
   TranType:= 0;
   TransCommon;
end;

procedure TForm1Cls.Trans_IntClick(Sender: TObject);
begin
   TranType:= 1;
   TransCommon;
end;

procedure TForm1Cls.Trans_StrClick(Sender: TObject);
begin
   TranType:= 2;
   TransCommon;
end;

procedure TForm1Cls.Rec_ByteClick(Sender: TObject);
begin
   TranType:= 3;
   TransCommon;
end;

procedure TForm1Cls.Rec_IntClick(Sender: TObject);
begin
   TranType:= 4;
   TransCommon;
end;

procedure TForm1Cls.Rec_StrClick(Sender: TObject);
begin
   TranType:= 5;
   TransCommon;
end;

procedure TForm1Cls.btnClose_Click(Sender: TObject);
var  lRetVal : longint;
begin
   lRetVal:= ECIO_Close;
   Text1.text:= Text1.text+'Close = '+IntToStr(lRetVal)+CR;
end;

procedure TForm1Cls.Form_Unload(Sender: TObject; var Action: TCloseAction);
begin //Make sure the connection is closed
   ECIO_Close;
end;

procedure TForm1Cls.TransCommon;
var bDataIn, bDataOut: ArByte;
    DataInt: Array [0..15] of integer;
    lRetVal, nRxDataCnt, nTxDataCnt, StartT, EndT : Longint;
    StrLen, n, m : Byte;
begin
  Case TranType of
    0: begin //Transmit Array of Byte
         Byte0.text:= '0';
         bDataOut[0]:= 0;
         bDataOut[1]:= StrToInt(Nos1.text);
         bDataOut[2]:= StrToInt(Nos2.text);
         bDataOut[3]:= StrToInt(Nos3.text);
         bDataOut[4]:= StrToInt(Nos4.text);
         bDataOut[5]:= StrToInt(Nos5.text);
         bDataOut[6]:= StrToInt(Nos6.text);
       end;
    1: begin //Transmit Array of Integer
         Byte0.text:= '1';
         bDataOut[0]:= 1;
         DataInt[1]:= StrToInt(Nos1.text);
         DataInt[2]:= StrToInt(Nos2.text);
         DataInt[3]:= StrToInt(Nos3.text);
         DataInt[4]:= StrToInt(Nos4.text);
         DataInt[5]:= StrToInt(Nos5.text);
         DataInt[6]:= StrToInt(Nos6.text);
         m:= 1;
         For n:= 1 to 6 do //Convert to 2 Bytes.
           begin bDataOut[m]:= DataInt[n] and $FF; m:= m+1;
                 bDataOut[m]:= (DataInt[n] and $FF00) div $100; m:= m+1
           end;
       end;
    2: begin //Transmit String
         Byte0.text:= '2';
         bDataOut[0]:= 2;
         StrLen:= length(Str.Text);
         if (StrLen > 30 ) then StrLen:= 30;
         For n:= 1 to StrLen do  //Convert to ASCII
           bDataOut[n]:= Byte(Str.Text[n]);
         bDataOut[n]:= 32; //Add Space
       end;
    3: begin //Receive Array of Byte
         Byte0.text:= '3';
         bDataOut[0]:= 3;
       end;
    4: begin //Receive Array of Integer
         Byte0.text:= '4';
         bDataOut[0]:= 4;
       end;
    5: begin //Receive String
         Byte0.text:= '5';
         bDataOut[0]:= 5;
        end;
  end;
  StartT:= TimeGetTime;
  lRetVal := ECIO_Transmit(bDataOut,32,@nTxDataCnt,bDataIn,32,@nRxDataCnt,100);
  EndT:= TimeGetTime;
  Text1.text := '';
  Text1.text := 'Transmit return = '+IntToStr(lRetVal)+CR;
  Text1.text := Text1.text+'Transmit rxDataCnt = '+IntToStr(nRxDataCnt)+CR;
  Text1.text := Text1.text+'Transmit txDataCnt = '+IntToStr(nTxDataCnt)+CR;
  Text1.text := Text1.text+'Transmit Time = '+IntToStr(EndT - StartT)+'ms'+CR;
  Case TranType of
    3: begin //Display Array of Byte
         Text1.text := Text1.text+IntToStr(bDataIn[0])+', '+IntToStr(bDataIn[1])+
          ', '+ IntToStr(bDataIn[2])+CR+IntToStr(bDataIn[3])+', '+
                IntToStr(bDataIn[4])+', '+IntToStr(bDataIn[5])+CR;
       end;
    4: begin //Display Array of Integer
         m:= 0;
         For n:= 0 to 5 do
           begin //Convert to a pos Integer
             DataInt[n]:= (bDataIn[m+1] * $100) + bDataIn[m];
             If bDataIn[m+1] > 127 then //Convert to a neg Integer
               DataInt[n]:= (DataInt[n] - $FFFF - 1);
             m:= m + 2;
           end;
         Text1.text := Text1.text+
                       IntToStr(DataInt[0])+', '+IntToStr(DataInt[1])+', '+
                       IntToStr(DataInt[2])+CR+IntToStr(DataInt[3])+', '+
                       IntToStr(DataInt[4])+', '+IntToStr(DataInt[5])+CR;
       end;
    5: begin //Display String
         For n:= 0 to 3 do Text1.Text:= Text1.Text+Chr(bDataIn[n]);
         Text1.Text:= Text1.Text+CR;
       end;
  end;
end;

end.
